#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <io.h>
#include <interrupt.h>

char gInfo[] __attribute__ ((progmem)) =  __TIME__ " " __DATE__;
char gEepromData[] __attribute__((section (".eeprom"))) = "Test";

/* Variable in External RAM (Battery Backed) */
unsigned long gMagicVal  __attribute__((section (".batram")));

#define MAGIC_VAL       0x5A0F0F5AUL



void test(void);
void EnableXRAM(void);




int main(void)
{
  unsigned char tmp;

  EnableXRAM();

  tmp=inp(DDRG);
  tmp|=(1<<3)|(1<<4);
  outp(tmp,DDRG);  /* Make PortG.3 and PortG.4 outputs */
  tmp=inp(PORTG);
  tmp|=(1<<3);
  tmp&=~(1<<4);
  outp(tmp,PORTG);  /* PG3 = VCC, PG4 = GND */

  while(1)
  {
    test();
  }

  return(0);
}


volatile int x,y,z;


/********************************************************************\
*                                                                    *
*   Show ATmega128 Hardware multiply                                 *
*                                                                    *
\********************************************************************/
void test(void)
{
  x=15;
  y=455;
  z=x*y;
}

/* 0 -> 3 */
#define WAIT_STATE  2
#define SRW10   6

void EnableXRAM(void)
{
  unsigned char tmp;

  tmp=inp(MCUCR);
  tmp|=(1<<SRE)|((WAIT_STATE&0x01)<<SRW10);
  outp(tmp,MCUCR);
  tmp=inp(XMCRA);
  tmp|=(1<<SRL2)|(((WAIT_STATE>>1)&0x01)<<SRW11);
  outp(tmp,XMCRA);  /*  0x8000 -> 0xFFFF set to WAIT_STATE wait states */
}


